package com.ozs.web.controller.shotschedule;

import com.ozs.common.utils.uuid.IdUtils;
import com.ozs.service.entity.vo.BaseCameraVO;
import com.ozs.service.service.impl.CameraCaptureService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import javax.annotation.Resource;
import java.net.URL;
import java.util.concurrent.CountDownLatch;

/**
 * @author lyao
 * @description 生成监控图片
 * @creat 2024/3/14
 */
@Slf4j
@Service
public class GenPictureTaskService {

    /**
     * 摄像头截图服务接口
     */
    @Resource
    CameraCaptureService cameraCaptureService;

    @Value("${shot.urlAddress}")
    private String urlAddress;

    public boolean getNormalPicture(String cameraCode, String channel, String address, String ymd) {
        String uuid = IdUtils.fastSimpleUUID();
        long start = System.currentTimeMillis();
        if (!ObjectUtils.isEmpty(cameraCode)) {
            try {
//                if (log.isDebugEnabled()) {
//                    log.debug("请求url======" + urlAddress + cameraCode + "/" + channel);
//                }
                URL url = new URL(urlAddress + cameraCode + "/" + channel);
                String fileName = address + "/" + "normal" + "/" + ymd + "/" + uuid + ".jpeg";
//                if (log.isDebugEnabled()) {
//                    log.debug("正常摄像头截图开始, url: " + url + ", fileName: " + fileName);
//                }
                boolean capture = cameraCaptureService.getCapture(url, cameraCode, fileName);
//                if (log.isDebugEnabled()) {
//                    log.debug("正常摄像头截图结束, url: " + url + (capture ? "" : ", 出现错误") + ", 共计耗时: " + ((System.currentTimeMillis() - start) / 1000) + "s");
//                }
                return capture;
            } catch (Throwable e) {
                log.error("正常摄像头截图异常", e);
            }
        }
        return false;
    }

}
